package com.demo.controller;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Contro extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doPost(req, resp);
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String body = null;

		String uri = req.getRequestURI();
		//System.out.println(uri);
		// 云通讯IVR启动业务的回调请求，请求的url中固定相对地址startservice
		if (uri.contains("/startservice")) {
			body = startserver(req);
		}
		// 云通讯呼转命令的回调请求，通知第三方用户的按键超时，请求URL中的相对地址gettimeout可以自定义，demo中自定义为gettimeout
		if (uri.contains("/gettimeout")) {
			body = gettimeout(req);
		}
		// 云通讯按键命令的回调请求，通知第三方用户的按键信息，请求URL中的相对地址firstget可以自定义，demo中自定义为firstget
		if (uri.contains("/firstget")) {
			body = firstget(req);
		}
		//云通讯按键命令的回调请求，通知第三方用户的按键信息，请求URL中的相对地址joinconfget可以自定义，demo中自定义为joinconfget
		if (uri.contains("/joinconfget")) {
			body = joinconfget(req);
		}
		//云通讯创建会议的回调请求，通知第三方创建会议成功，请求URL中的相对地址createconfok可以自定义，demo中自定义为createconfok
		if (uri.contains("/createconfok")) {
			body = createconfok(req);
		}
		//云通讯创建会议后放音提示完的回调请求，通知第三方放音提示用户完成，请求URL中的相对地址autojoinconf可以自定义，demo中自定义为autojoinconf
		if (uri.contains("/autojoinconf")) {
			body = autojoinconf(req);
		}
		//云通讯加入会议成功的回调请求，通知第三方用户加入会议成功，请求URL中的相对地址joinconfok可以自定义，demo中自定义为joinconfok
		if (uri.contains("/joinconfok")) {
			body = joinconfok(req);
		}
		//云通讯加入会议失败的回调请求，通知第三方用户加入会议失败，请求URL中的相对地址joinconffail可以自定义，demo中自定义为joinconffail
		if (uri.contains("/joinconffail")) {
			body = joinconffail(req);
		}
		// 云通讯IVR结束业务的回调请求，请求的url中固定相对地址stopservice
		if (uri.contains("/stopservice")) {
			body = stopservice(req);
		}
		PrintWriter out = resp.getWriter();
		out.println(body);
	}

	// IVR启动业务，在IVR呼入或者IVR外呼后由云通讯平台发起的回调请求
	public String startserver(HttpServletRequest req) {
		// // 打印URL中的参数
		// Map map = req.getParameterMap();
		// Set<String> keySet = map.keySet();
		// for (String key : keySet) {
		// String[] values = (String[]) map.get(key);
		// for (String value : values) {
		// System.out.println(key + "=" + value);
		// }
		// }
		// 获取URL中的参数
		String appid = req.getParameter("appid");					//应用id
		String callid = req.getParameter("callid");				//通话id，由云通讯平台产生的一路通话的唯一标识
		String from = req.getParameter("from");						//主叫号码，当IVR呼入方式为主叫的号码，当IVR外呼的方式则为空
		String to = req.getParameter("to");								//被叫号码，当IVR呼入方式为IVR接入号，当IVR外呼的方式则为外呼的号码
		String direction = req.getParameter("direction");	//呼叫方式，IVR呼入为0，IVR外呼为1
		//String userdata = req.getParameter("userdata");	//自定义参数，只有发起当外呼请求中带有才会返回，可以通过该参数和callid绑定来确定发起的请求
	  //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后跳转到gettimeout
	  //命令中action='dtmfreport'为自定义按键回调相对地址
	  //numdigits='1'定义按键个数为1，当用户按任意一个键就会通知第三方服务器
	  //timeout='30'为用户按键超时时间30秒，当放音第一次完成后开始计时，用户30秒没有按键就会执行副命令
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='firstget' numdigits='1' timeout='30'><Play>confmenu.wav</Play></Get><Redirect tag='1'>gettimeout</Redirect></Response>";
		return result;
	}

	//用户按键超时
	public String gettimeout(HttpServletRequest req) {
		String result ="";
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		String tag = req.getParameter("tag");				//Redirect中自定义的tag值
	  //对云通讯平台回调请求的响应包体，响应的是按键命令嵌套放音，超时没按键就放音提示用户后挂断用户
		if(tag.equals("1")){
			//主菜单的用户按键超时
			result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='firstget' numdigits='1' timeout='30'><Play>confmenu.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup /></Response>";
		}else if(tag.equals("2")){
			//用户输入会议号按键超时
			result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='joinconfget' numdigits='8' timeout='30'><Play>confjoin.wav</Play></Get><Play>timeoutbye.wav</Play><Hangup /></Response>";
		}
		
		return result;
	}
	
	//主菜单用户按键
	public String firstget(HttpServletRequest req) {
		String result ="";
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");	//用户按键内容
		//对云通讯平台回调请求的响应包体，响应的是放音提示后挂断用户电话
		System.out.println(digits);
		if(digits.equals("1")){
			//主菜单用户按1键后创建会议
			result = "<?xml version='1.0' encoding='UTF-8'?><Response><CreateConf action='createconfok' maxmember='10' autojoin='false'/></Response>";
		}else if(digits.equals("2")){
			//主菜单用户按2键后创建提示用户输入会议号，用户没按键就放音提示用户后跳转到gettimeout
			result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='joinconfget' numdigits='8' timeout='30'><Play>confjoin.wav</Play></Get><Redirect tag='2'>gettimeout</Redirect></Response>";
		}else {
			//主菜单用户按1和2之外的其他键则放音提示主菜单信息，用户没按键就放音提示用户后跳转到gettimeout
			result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='firstget' numdigits='1' timeout='30'><Play>confmenu.wav</Play></Get><Redirect tag='1'>gettimeout</Redirect></Response>";
		}
		return result;
	}
	
	//用户输入会议号后加入会议
	public String joinconfget(HttpServletRequest req) {
		
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");	//用户按键内容
		//对云通讯平台回调请求的响应包体，通过用户输入的会议号进行加入会议，如果加入会议失败则跳转到joinconffail
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><JoinConf action='joinconfok' confid='"+digits+"'/><Redirect>joinconffail</Redirect></Response>";
		return result;
	}
	
	String confid="";	//定义会议id的变量
	//创建会议成功
	public String createconfok(HttpServletRequest req) {
		
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		confid = req.getParameter("confid");				//会议id
		String createtime = req.getParameter("createtime");//会议创建时间
		//对云通讯平台回调请求的响应包体，创建会议成功后提示用户创建的会议号，方便用户告知其他用户会议号，放音完成后跳转到autojoinconf
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><PlayMix type='40'>createconf.wav;"+confid+"</PlayMix><Redirect>autojoinconf</Redirect></Response>";
		return result;
	}
	
	//会议号播报完成
	public String autojoinconf(HttpServletRequest req) {
		
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		//对云通讯平台回调请求的响应包体，在会议号播报完成后让用户自动加入会议，如果加入会议失败则跳转到joinconffail
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><JoinConf action='joinconfok' confid='"+confid+"'/><Redirect>joinconffail</Redirect></Response>";
		return result;
	}
	
	//加入会议成功
	public String joinconfok(HttpServletRequest req) {
		
		// 获取URL中的参数
		String appid = req.getParameter("appid");				//应用id
		String callid = req.getParameter("callid");			//通话id，由云通讯平台产生的一路通话的唯一标识
		String confid = req.getParameter("confid");			//会议id
		String jointime = req.getParameter("jointime");	//加入会议的时间
		String number = req.getParameter("number");			//加入会议的号码	
		//对云通讯平台回调请求的响应包体，加入会议成功后不需要后续流程响应空命令即可
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><CmdNone/></Response>";
		return result;
	}
	
	//加入会议失败
	public String joinconffail(HttpServletRequest req) {
		
		// 获取URL中的参数
		String appid = req.getParameter("appid");		//应用id
		String callid = req.getParameter("callid");	//通话id，由云通讯平台产生的一路通话的唯一标识
		String digits = req.getParameter("digits");	//用户按键内容
		//对云通讯平台回调请求的响应包体，加入会议失败后提示用户重新输入会议号加入会议，用户没按键就放音提示用户后跳转到gettimeout
		String result = "<?xml version='1.0' encoding='UTF-8'?><Response><Get action='joinconfget' numdigits='8' timeout='30'><Play>confjoinfail.wav</Play></Get><Play>timeout.wav</Play><Redirect tag='2'>gettimeout</Redirect></Response>";
		return result;
	}

	//IVR结束业务，在用户挂机后由云通讯平台发起的回调请求
	public String stopservice(HttpServletRequest req) {
		// 获取URL中的参数
		String appid = req.getParameter("appid");											//应用id
		String callid = req.getParameter("callid");										//通话id，由云通讯平台产生的一路通话的唯一标识
		String starttime = req.getParameter("starttime");							//主叫通话的开始时间
		String endtime = req.getParameter("endtime");									//主叫通话的结束时间
		String callduration = req.getParameter("callduration");				//主叫通话时长
		String sstime = req.getParameter("sstime");										//被叫通话的开始时间，会议不存被叫此参数忽略
		String setime = req.getParameter("setime");										//被叫通话的结束时间，会议不存被叫此参数忽略
		String seccallduration = req.getParameter("seccallduration");	//被叫通话时间，会议不存被叫此参数忽略
		String recordurl = req.getParameter("recordurl");							//录音文件下载地址，当会议中有录音此参数有效
		String recordid = req.getParameter("recordid");								//录音文件Id，当会议中有录音此参数有效
		String errorcode = req.getParameter("errorcode");							//通话中异常的错误值，可以根据错误知道出现异常的原因
		// 响应包体
		String result = "<?xml version='1.0' encoding='UTF-8' ?><Response><CmdNone/></Response>";
		return result;
	}

}
